/******************************************************************************

                              Online C++ Compiler.
               Code, Compile, Run and Debug C++ program online.
Write your code in this editor and press "Run" button to compile and execute it.

*******************************************************************************/

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i=0;i<n;i++) cin >> a[i];
    int poslednji[10];
    for(int i=0;i<10;i++) poslednji[i]=-1;
    for(int i=n-1;i>=0;i--)
    {
        if(poslednji[a[i]]==-1) poslednji[a[i]]=i;
    }
    for(int i=0;i<n;i++)
    {
        for(int j=9;j>a[i];j--)
        {
            if(poslednji[j]>i)
            {
                swap(a[i],a[poslednji[j]]);
                for(int k=0;k<n;k++) cout << a[k] << " ";
                return 0;
            }
        }
    }
    for(int i=1;i<n;i++)
    {
        if(a[i]==a[i-1])
        {
            for(int k=0;k<n;k++) cout << a[k] << " ";
            return 0;
        }
    }
    swap(a[n-2],a[n-1]);
    for(int i=0;i<n;i++) cout << a[i] << " ";
    return 0;
}